Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public NotInheritable Class MainWindowViewModel
	Implements INotifyPropertyChanged
	Public Sub New()
		Url = "http://www.example.com/"
        CountUrlBytesCommand = New AsyncCommand(Async Function() ByteCount = Await MyService.DownloadAndCountBytesAsync(Url))
	End Sub

	Private _url As String
	Public Property Url() As String
		Get
			Return _url
		End Get
		Set(ByVal value As String)
			_url = value
			OnPropertyChanged()
		End Set
	End Property

	Private privateCountUrlBytesCommand As IAsyncCommand
	Public Property CountUrlBytesCommand() As IAsyncCommand
		Get
			Return privateCountUrlBytesCommand
		End Get
		Private Set(ByVal value As IAsyncCommand)
			privateCountUrlBytesCommand = value
		End Set
	End Property

	Private _byteCount As Integer
	Public Property ByteCount() As Integer
		Get
			Return _byteCount
		End Get
		Private Set(ByVal value As Integer)
			_byteCount = value
			OnPropertyChanged()
		End Set
	End Property

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(<CallerMemberName> Optional ByVal propertyName As String = Nothing)
        Dim handler As PropertyChangedEventHandler = PropertyChangedEvent
        If handler IsNot Nothing Then
            handler(Me, New PropertyChangedEventArgs(propertyName))
        End If
    End Sub
End Class
