Public NotInheritable Class DelegateCommand
	Implements ICommand
	Private ReadOnly _command As Action

	Public Sub New(ByVal command As Action)
		_command = command
	End Sub

	Public Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
		_command()
	End Sub

	Private Function CanExecute(ByVal parameter As Object) As Boolean Implements ICommand.CanExecute
		Return True
	End Function

	Private Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
		AddHandler(ByVal value As EventHandler)
		End AddHandler
		RemoveHandler(ByVal value As EventHandler)
		End RemoveHandler
		RaiseEvent(ByVal sender As Object, ByVal e As EventArgs)
		End RaiseEvent
	End Event
End Class
