Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Threading.Tasks

Public NotInheritable Class MainWindowViewModel
	Implements INotifyPropertyChanged
	Public Sub New()
		Url = "http://www.example.com/"
        CountUrlBytesCommand = AsyncCommand.Create(Function(token) MyService.DownloadAndCountBytesAsync(Url, token))
	End Sub

	Private _url As String
	Public Property Url() As String
		Get
			Return _url
		End Get
		Set(ByVal value As String)
			_url = value
			OnPropertyChanged()
		End Set
	End Property

	Private privateCountUrlBytesCommand As IAsyncCommand
	Public Property CountUrlBytesCommand() As IAsyncCommand
		Get
			Return privateCountUrlBytesCommand
		End Get
		Private Set(ByVal value As IAsyncCommand)
			privateCountUrlBytesCommand = value
		End Set
	End Property

	Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(<CallerMemberName> Optional ByVal propertyName As String = Nothing)
        Dim handler As PropertyChangedEventHandler = PropertyChangedEvent
        If handler IsNot Nothing Then
            handler(Me, New PropertyChangedEventArgs(propertyName))
        End If
    End Sub
End Class
