Imports System.Threading.Tasks

Public MustInherit Class AsyncCommandBase
	Implements IAsyncCommand
	Public MustOverride Function CanExecute(ByVal parameter As Object) As Boolean Implements ICommand.CanExecute

	Public MustOverride Function ExecuteAsync(ByVal parameter As Object) As Task Implements IAsyncCommand.ExecuteAsync

	Public async Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
		await ExecuteAsync(parameter)
	End Sub

	Public Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
		AddHandler(ByVal value As EventHandler)
			AddHandler CommandManager.RequerySuggested, value
		End AddHandler
		RemoveHandler(ByVal value As EventHandler)
			RemoveHandler CommandManager.RequerySuggested, value
		End RemoveHandler
		RaiseEvent(ByVal sender As Object, ByVal e As EventArgs)
            CanExecute(sender)
		End RaiseEvent
	End Event

	Protected Sub RaiseCanExecuteChanged()
		CommandManager.InvalidateRequerySuggested()
	End Sub
End Class
